
// unembed.cpp - convert an embedding back to an edge list
// (c) 2009 Nic Schraudolph - see COPYRIGHT.txt for details

#include <fstream>
#include "graph.hpp"

int main(int argc, char** argv)
{
    std::filebuf* fb;

    Isinf::argv0 = argv[0];
    if (argc > 2)
    {
        std::cerr << "usage: " << argv[0]
            << " [<] <embedding> > <edgelist>" << std::endl;
        exit(1);
    }
    else if (argc == 2)
    {
        fb = new std::filebuf;
        if (fb->open(argv[1], std::ios::in) == NULL)
        {
            std::cerr << Isinf::argv0 << "can't open embedding '"
                << argv[1] << "' for input" << std::endl;
            exit(2);
        }
    }
    else fb = (std::filebuf*) std::cin.rdbuf();
    std::istream input(fb);
    Isinf::Graph g(input);

    for (size_t i = 0; i < g.edges.size(); ++i)
        std::cout << g.edges[i]->node << ' '
            << g.edges[i]->other->node  << std::endl;
}

